var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
define(["require", "exports", "react", "office-ui-fabric-react/lib/Button", "office-ui-fabric-react/lib/FocusTrapZone", "office-ui-fabric-react/lib/Toggle", "office-ui-fabric-react/lib/Utilities", "./FocusTrapZone.Box.Example.scss"], function (require, exports, React, Button_1, FocusTrapZone_1, Toggle_1, Utilities_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FocusTrapComponent = (function (_super) {
        __extends(FocusTrapComponent, _super);
        function FocusTrapComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FocusTrapComponent.prototype.render = function () {
            var contents = (React.createElement("div", { className: 'ms-FocusTrapComponent' },
                React.createElement(Button_1.Button, { onClick: this._onStringButtonClicked }, this.props.name),
                React.createElement(Toggle_1.Toggle, { ref: 'toggle', checked: this.props.isActive, onChanged: this._onFocusTrapZoneToggleChanged, label: 'Focus Trap Zone', onText: 'On', offText: 'Off' }),
                this.props.children));
            if (this.props.isActive) {
                return (React.createElement(FocusTrapZone_1.FocusTrapZone, { forceFocusInsideTrap: false }, contents));
            }
            return contents;
        };
        FocusTrapComponent.prototype._onStringButtonClicked = function () {
            console.log(this.props.name);
        };
        FocusTrapComponent.prototype._onFocusTrapZoneToggleChanged = function (isChecked) {
            this.props.setIsActive(this.props.name, isChecked);
        };
        return FocusTrapComponent;
    }(React.Component));
    __decorate([
        Utilities_1.autobind
    ], FocusTrapComponent.prototype, "_onStringButtonClicked", null);
    __decorate([
        Utilities_1.autobind
    ], FocusTrapComponent.prototype, "_onFocusTrapZoneToggleChanged", null);
    var NAMES = ['One', 'Two', 'Three', 'Four', 'Five'];
    var FocusTrapZoneNestedExample = (function (_super) {
        __extends(FocusTrapZoneNestedExample, _super);
        function FocusTrapZoneNestedExample() {
            var _this = _super.call(this) || this;
            _this.state = {
                stateMap: {}
            };
            return _this;
        }
        FocusTrapZoneNestedExample.prototype.render = function () {
            var stateMap = this.state.stateMap;
            return (React.createElement("div", null,
                React.createElement(FocusTrapComponent, { name: 'One', isActive: !!stateMap['One'], setIsActive: this._setIsActive },
                    React.createElement(FocusTrapComponent, { name: 'Two', isActive: !!stateMap['Two'], setIsActive: this._setIsActive },
                        React.createElement(FocusTrapComponent, { name: 'Three', isActive: !!stateMap['Three'], setIsActive: this._setIsActive }),
                        React.createElement(FocusTrapComponent, { name: 'Four', isActive: !!stateMap['Four'], setIsActive: this._setIsActive })),
                    React.createElement(FocusTrapComponent, { name: 'Five', isActive: !!stateMap['Five'], setIsActive: this._setIsActive })),
                React.createElement(Button_1.Button, { onClick: this._randomize }, "Randomize")));
        };
        FocusTrapZoneNestedExample.prototype._setIsActive = function (name, isActive) {
            this.state.stateMap[name] = isActive;
            this.forceUpdate();
        };
        FocusTrapZoneNestedExample.prototype._randomize = function () {
            var _this = this;
            NAMES.forEach(function (name) {
                _this.state.stateMap[name] = Math.random() >= .5;
            });
            this.forceUpdate();
        };
        return FocusTrapZoneNestedExample;
    }(React.Component));
    __decorate([
        Utilities_1.autobind
    ], FocusTrapZoneNestedExample.prototype, "_setIsActive", null);
    __decorate([
        Utilities_1.autobind
    ], FocusTrapZoneNestedExample.prototype, "_randomize", null);
    exports.default = FocusTrapZoneNestedExample;
});

//# sourceMappingURL=FocusTrapZone.Nested.Example.js.map
