var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "@uifabric/example-app-base", "./examples/List.Basic.Example", "./examples/List.Mail.Example", "./examples/List.Grid.Example", "./examples/List.Scrolling.Example", "@uifabric/example-app-base"], function (require, exports, React, example_app_base_1, List_Basic_Example_1, List_Mail_Example_1, List_Grid_Example_1, List_Scrolling_Example_1, example_app_base_2) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ListBasicExampleCode = require('!raw-loader!./examples/List.Basic.Example.tsx');
    var ListMailExampleCode = require('!raw-loader!./examples/List.Mail.Example.tsx');
    var ListGridExampleCode = require('!raw-loader!./examples/List.Grid.Example.tsx');
    var ListScrollingExampleCode = require('!raw-loader!./examples/List.Scrolling.Example.tsx');
    var _cachedItems;
    var ListPage = (function (_super) {
        __extends(ListPage, _super);
        function ListPage() {
            var _this = _super.call(this) || this;
            _cachedItems = _cachedItems || example_app_base_2.createListItems(5000);
            return _this;
        }
        ListPage.prototype.render = function () {
            return (React.createElement(example_app_base_1.ComponentPage, { title: 'List', componentName: 'ListExample', exampleCards: React.createElement("div", null,
                    React.createElement(example_app_base_1.ExampleCard, { title: 'List of 5000 grid items', isOptIn: true, code: ListGridExampleCode },
                        React.createElement(List_Grid_Example_1.ListGridExample, { items: _cachedItems })),
                    React.createElement(example_app_base_1.ExampleCard, { title: 'List of 5000 variable height items', isOptIn: true, code: ListBasicExampleCode },
                        React.createElement(List_Basic_Example_1.ListBasicExample, { items: _cachedItems })),
                    React.createElement(example_app_base_1.ExampleCard, { title: 'Fixed list of 5000 email tiles', isOptIn: true, code: ListMailExampleCode },
                        React.createElement(List_Mail_Example_1.ListMailExample, { items: _cachedItems })),
                    React.createElement(example_app_base_1.ExampleCard, { title: 'Scrolling items into view', isOptIn: true, code: ListScrollingExampleCode },
                        React.createElement(List_Scrolling_Example_1.ListScrollingExample, { items: _cachedItems }))), propertiesTables: React.createElement(example_app_base_1.PropertiesTableSet, { sources: [
                        require('!raw-loader!office-ui-fabric-react/lib/components/List/List.Props.ts')
                    ] }), overview: React.createElement("div", null,
                    React.createElement("p", null,
                        React.createElement("span", null, "List provides a base component for rendering large sets of items. It is agnostic of layout, the tile component used, and selection management. These concerns can be layered separately.")),
                    React.createElement("p", null,
                        React.createElement("b", null, "Performance is important, and DOM content is expensive. Therefore limit what you render."),
                        " Unlike a simple for loop that renders all items in a set, a List uses ui virtualization. It only renders a subset of items, and as you scroll around, the subset of rendered content is shifted to what you're looking at. This gives a much better experience for large sets, especially when the per-item components are complex/render intensive/network intensive."),
                    React.createElement("p", null, "Lists break down the set of items passed in into pages. Only pages within a \"materialized window\" are actually rendered. As that window changes due to scroll events, pages that fall outside that window are removed, and their layout space is remembered and pushed into spacer elements. This gives the user the experience of browsing massive amounts of content but only using a small number of actual elements. This gives the browser much less layout to resolve, and gives React DOM diffing much less content to worry about.")), related: React.createElement("a", { href: 'https://dev.office.com/fabric-js/Components/List/List.html' }, "Fabric JS"), isHeaderVisible: this.props.isHeaderVisible }));
        };
        return ListPage;
    }(React.Component));
    exports.ListPage = ListPage;
});

//# sourceMappingURL=ListPage.js.map
