"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utilities_1 = require("@uifabric/utilities");
var index_1 = require("office-ui-fabric-react/lib/index");
require("./List.Scrolling.Example.scss");
var evenItemHeight = 25;
var oddItemHeight = 50;
var numberOfItemsOnPage = 10;
var ListScrollingExample = (function (_super) {
    __extends(ListScrollingExample, _super);
    function ListScrollingExample(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            selectedIndex: 0
        };
        return _this;
    }
    ListScrollingExample.prototype.render = function () {
        var _this = this;
        var items = this.props.items;
        return (React.createElement(index_1.FocusZone, { direction: index_1.FocusZoneDirection.vertical },
            React.createElement("div", null,
                React.createElement(index_1.Button, { onClick: function () { return _this._scrollRelative(-10); } }, "-10"),
                React.createElement(index_1.Button, { onClick: function () { return _this._scrollRelative(-1); } }, "-1"),
                React.createElement(index_1.Button, { onClick: function () { return _this._scrollRelative(1); } }, "+1"),
                React.createElement(index_1.Button, { onClick: function () { return _this._scrollRelative(10); } }, "+10")),
            React.createElement("div", null,
                "Scroll item index:",
                React.createElement(index_1.TextField, { value: this.state.selectedIndex.toString(10), onChanged: function (value) {
                        _this._scroll(parseInt(value, 10) || 0);
                    } })),
            React.createElement("div", { className: 'ms-ListScrollingExample-container', "data-is-scrollable": true },
                React.createElement(index_1.List, { ref: this._resolveList, items: items, getPageHeight: function (idx) {
                        var h = 0;
                        for (var i = idx; i < idx + numberOfItemsOnPage; ++i) {
                            var isEvenRow = i % 2 === 0;
                            h += isEvenRow ? evenItemHeight : oddItemHeight;
                        }
                        return h;
                    }, onRenderCell: function (item, index) { return (React.createElement("div", { className: 'ms-ListScrollingExample-itemCell', "data-is-focusable": true },
                        React.createElement("div", { className: utilities_1.css('ms-ListScrollingExample-itemContent', {
                                'ms-ListScrollingExample-itemContent-even': index % 2 === 0,
                                'ms-ListScrollingExample-itemContent-odd': index % 2 === 1
                            }) },
                            index,
                            " \u00A0 ",
                            item.name))); } }))));
    };
    ListScrollingExample.prototype._scrollRelative = function (delta) {
        this._scroll(this.state.selectedIndex + delta);
    };
    ListScrollingExample.prototype._scroll = function (index) {
        var _this = this;
        var updatedSelectedIndex = Math.min(Math.max(index, 0), this.props.items.length - 1);
        this.setState({
            selectedIndex: updatedSelectedIndex
        }, function () {
            _this._list.scrollToIndex(updatedSelectedIndex, function (idx) { return idx % 2 === 0 ? evenItemHeight : oddItemHeight; });
        });
    };
    ListScrollingExample.prototype._resolveList = function (list) {
        this._list = list;
    };
    return ListScrollingExample;
}(React.Component));
__decorate([
    utilities_1.autobind
], ListScrollingExample.prototype, "_resolveList", null);
exports.ListScrollingExample = ListScrollingExample;

//# sourceMappingURL=List.Scrolling.Example.js.map
