"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var example_app_base_1 = require("@uifabric/example-app-base");
var Panel_SmallRight_Example_1 = require("./examples/Panel.SmallRight.Example");
var Panel_SmallLeft_Example_1 = require("./examples/Panel.SmallLeft.Example");
var Panel_SmallFluid_Example_1 = require("./examples/Panel.SmallFluid.Example");
var Panel_Medium_Example_1 = require("./examples/Panel.Medium.Example");
var Panel_Large_Example_1 = require("./examples/Panel.Large.Example");
var Panel_LargeFixed_Example_1 = require("./examples/Panel.LargeFixed.Example");
var Panel_ExtraLarge_Example_1 = require("./examples/Panel.ExtraLarge.Example");
var Panel_LightDismiss_Example_1 = require("./examples/Panel.LightDismiss.Example");
var Panel_NonModal_Example_1 = require("./examples/Panel.NonModal.Example");
var PanelSmallRightExampleCode = require('!raw-loader!./examples/Panel.SmallRight.Example.tsx');
var PanelSmallLeftExampleCode = require('!raw-loader!./examples/Panel.SmallLeft.Example.tsx');
var PanelSmallFluidExampleCode = require('!raw-loader!./examples/Panel.SmallFluid.Example.tsx');
var PanelMediumExampleCode = require('!raw-loader!./examples/Panel.Medium.Example.tsx');
var PanelLargeExampleCode = require('!raw-loader!./examples/Panel.Large.Example.tsx');
var PanelLargeFixedExampleCode = require('!raw-loader!./examples/Panel.LargeFixed.Example.tsx');
var PanelExtraLargeExampleCode = require('!raw-loader!./examples/Panel.ExtraLarge.Example.tsx');
var PanelLightDismissExampleCode = require('!raw-loader!./examples/Panel.LightDismiss.Example.tsx');
var PanelNonModalExampleCode = require('!raw-loader!./examples/Panel.NonModal.Example.tsx');
var PanelPage = (function (_super) {
    __extends(PanelPage, _super);
    function PanelPage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PanelPage.prototype.render = function () {
        return (React.createElement(example_app_base_1.ComponentPage, { title: 'Panel', componentName: 'PanelExample', exampleCards: React.createElement("div", null,
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Small Panel, Anchored Right, Fixed Width', code: PanelSmallRightExampleCode },
                    React.createElement(Panel_SmallRight_Example_1.PanelSmallRightExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Small Panel, Anchored Left, Fixed Width', code: PanelSmallLeftExampleCode },
                    React.createElement(Panel_SmallLeft_Example_1.PanelSmallLeftExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Small Panel, Full Screen, Fluid Width', code: PanelSmallFluidExampleCode },
                    React.createElement(Panel_SmallFluid_Example_1.PanelSmallFluidExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Medium', code: PanelMediumExampleCode },
                    React.createElement(Panel_Medium_Example_1.PanelMediumExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Large', code: PanelLargeExampleCode },
                    React.createElement(Panel_Large_Example_1.PanelLargeExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - LargeFixed', code: PanelLargeFixedExampleCode },
                    React.createElement(Panel_LargeFixed_Example_1.PanelLargeFixedExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Extra Large', code: PanelExtraLargeExampleCode },
                    React.createElement(Panel_ExtraLarge_Example_1.PanelExtraLargeExample, null)),
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Light Dismiss', code: PanelLightDismissExampleCode },
                    React.createElement(Panel_LightDismiss_Example_1.PanelLightDismissExample, null)),
                ",",
                React.createElement(example_app_base_1.ExampleCard, { title: 'Panel - Non-Modal', code: PanelNonModalExampleCode },
                    React.createElement(Panel_NonModal_Example_1.PanelNonModalExample, null))), propertiesTables: React.createElement(example_app_base_1.PropertiesTableSet, { sources: [
                    require('!raw-loader!office-ui-fabric-react/lib/components/Panel/Panel.Props.ts')
                ] }), overview: React.createElement("div", null,
                React.createElement("p", null, "Panels are modal UI overlays that provide contextual app information. They often request some kind of creation or management action from the user. Panels are paired with the Overlay component, also known as a Light Dismiss. The Overlay blocks interactions with the app view until dismissed either through clicking or tapping on the Overlay or by selecting a close or completion action within the Panel."),
                React.createElement("h2", { className: 'ms-font-xl' }, "Examples of experiences that use Panels"),
                React.createElement("ul", null,
                    React.createElement("li", null, "Member or group list creation or management"),
                    React.createElement("li", null, "Document list creation or management"),
                    React.createElement("li", null, "Permissions creation or management"),
                    React.createElement("li", null, "Settings creation or management"),
                    React.createElement("li", null, "Multi-field forms"))), bestPractices: React.createElement("div", null), dos: React.createElement("div", null,
                React.createElement("ul", null,
                    React.createElement("li", null, "Use for self-contained experiences where the user does not need to interact with the app view to complete the task. "),
                    React.createElement("li", null, "Use for complex creation, edit or management experiences."),
                    React.createElement("li", null, "Consider how the panel and its contained contents will scale across Fabric\u2019s responsive web breakpoints."))), donts: React.createElement("div", null,
                React.createElement("ul", null,
                    React.createElement("li", null, "Use for experiences where the user needs to interact with the app view. Use a Pane (which pushes content, doesn\u2019t use an overlay, and sits on the same z-index as the rest of the UI) instead."))), related: React.createElement("a", { href: 'https://dev.office.com/fabric-js/Components/Panel/Panel.html' }, "Fabric JS"), isHeaderVisible: this.props.isHeaderVisible }));
    };
    return PanelPage;
}(React.Component));
exports.PanelPage = PanelPage;

//# sourceMappingURL=PanelPage.js.map
